
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <unistd.h>

GtkWidget *text1, *text2, *text3, *text4, *about, *label;
int pid, check = 0;

void attiva (void);
void disattiva (void);
void chiudi (void);
void show_about (void);
void destroy_about (void);

int main( int   argc, char *argv[] )
{
	GtkWidget *window, *button, *hbox, *vbox;
	gchar *modprobe;

	modprobe = malloc(12*sizeof(gchar));
	sprintf(modprobe,"modprobe tun");
	system(modprobe);
	free(modprobe);

	gtk_init(&argc, &argv);

	// --- Creazione della GUI e gestione dei segnai
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), "OpenVPN Gui");
	gtk_container_set_border_width (GTK_CONTAINER (window), 5);
	g_signal_connect (G_OBJECT (window), "destroy",G_CALLBACK (gtk_main_quit),NULL);
	gtk_window_set_resizable (GTK_WINDOW(window), FALSE);
	gtk_window_set_position (GTK_WINDOW(window), GTK_WIN_POS_CENTER_ALWAYS);

	vbox = gtk_vbox_new (TRUE, 5);
	gtk_container_add (GTK_CONTAINER (window), vbox);

	hbox = gtk_hbox_new (TRUE, 5);
	gtk_container_add (GTK_CONTAINER (vbox), hbox);
	label = gtk_label_new("");
	gtk_label_set_markup (GTK_LABEL(label),"<span size='large' color='Black'>Host Locale Privato</span>");
	text1 = gtk_entry_new();
	gtk_container_add (GTK_CONTAINER (hbox), label);
	gtk_container_add (GTK_CONTAINER (hbox), text1);

	hbox = gtk_hbox_new (TRUE, 5);
	gtk_container_add (GTK_CONTAINER (vbox), hbox);
	label = gtk_label_new("");
	gtk_label_set_markup (GTK_LABEL(label),"<span size='large' color='Black'>Host Remoto Privato</span>");
	text2 = gtk_entry_new();
	gtk_container_add (GTK_CONTAINER (hbox), label);
	gtk_container_add (GTK_CONTAINER (hbox), text2);

	hbox = gtk_hbox_new (TRUE, 5);
	gtk_container_add (GTK_CONTAINER (vbox), hbox);
	label = gtk_label_new("");
	gtk_label_set_markup (GTK_LABEL(label),"<span size='large' color='Black'>Host Remoto Pubblico</span>");
	text3 = gtk_entry_new();
	gtk_container_add (GTK_CONTAINER (hbox), label);
	gtk_container_add (GTK_CONTAINER (hbox), text3);

	hbox = gtk_hbox_new (TRUE, 5);
	gtk_container_add (GTK_CONTAINER (vbox), hbox);
	label = gtk_label_new("");
	gtk_label_set_markup (GTK_LABEL(label),"<span size='large' color='Black'>Locazione della key</span>");
	text4 = gtk_entry_new();
	gtk_container_add (GTK_CONTAINER (hbox), label);
	gtk_container_add (GTK_CONTAINER (hbox), text4);

	hbox = gtk_hbox_new (TRUE, 5);
	gtk_container_add (GTK_CONTAINER (vbox), hbox);

	button = gtk_button_new();
	label = gtk_label_new("");
	gtk_label_set_markup (GTK_LABEL(label),"<span size='large' color='Black'>Connetti</span>");
	gtk_container_add (GTK_CONTAINER (button), label);
	gtk_container_add (GTK_CONTAINER (hbox), button);
	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (attiva), NULL);

	button = gtk_button_new();
	label = gtk_label_new("");
	gtk_label_set_markup (GTK_LABEL(label),"<span size='large' color='Black'>Disconnetti</span>");
	gtk_container_add (GTK_CONTAINER (button), label);
	gtk_container_add (GTK_CONTAINER (hbox), button);
	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (disattiva), NULL);

	button = gtk_button_new();
	label = gtk_label_new("");
	gtk_label_set_markup (GTK_LABEL(label),"<span size='large' color='Black'>Chiudi</span>");
	gtk_container_add (GTK_CONTAINER (button), label);
	gtk_container_add (GTK_CONTAINER (hbox), button);
	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (chiudi), NULL);

	button = gtk_button_new();
	label = gtk_label_new("");
	gtk_label_set_markup (GTK_LABEL(label),"<span size='large' color='Black'>About</span>");
	gtk_container_add (GTK_CONTAINER (button), label);
	gtk_container_add (GTK_CONTAINER (hbox), button);
	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (show_about), NULL);
	gtk_widget_show_all(window);
	// --- Gui Creata

	gtk_main ();
	return 0;
}

void attiva (void)
{
	FILE *oPid;
	pid = fork();

	// avvia openvpn con le caratteristiche richieste
	if (!pid)
	execlp("openvpn","openvpn","--remote",gtk_entry_get_text(GTK_ENTRY(text3)),"--dev","tun1","--ifconfig",gtk_entry_get_text(GTK_ENTRY(text1)),gtk_entry_get_text(GTK_ENTRY(text2)),"--verb","5","--secret",gtk_entry_get_text(GTK_ENTRY(text4)),NULL);

	// salva su file il pid del processo
	oPid = fopen("openVPN.pid","w");
	fprintf(oPid,"%d",pid);
	fclose(oPid);
}

void disattiva (void)
{
	// termina il processo di openvpn ed elimina lo "zombie"
	if (pid != 0) {
		kill(pid,9);
		waitpid(pid,NULL,0);
	}

	// setta a 0 il pid per indicare che nssun processo  runnato
	pid = 0;
}

void chiudi (void)
{
	// termina il processo di openvpn se questo  runnato
	if (pid != 0)
		kill(pid,9);
	// termina la gui
	gtk_main_quit();
}

void show_about (void)
{
	// --- Creazione finestra d'About
	if (check == 0 ) {
		about = gtk_window_new (GTK_WINDOW_TOPLEVEL);
		gtk_window_set_resizable (GTK_WINDOW(about), FALSE);
		gtk_window_set_position (GTK_WINDOW(about), GTK_WIN_POS_CENTER_ALWAYS);
		g_signal_connect (G_OBJECT (about), "destroy",G_CALLBACK (destroy_about),NULL);
		label = gtk_label_new ("");
		gtk_label_set_markup (GTK_LABEL(label),"<span size='large' color='Blue'> OpenvpnGUI V1.0 rappresenta l'interfaccia grafica per\n openvpn, il \"secure IP tunnel daemon\".\n Scritto da Nazgul, sviluppato assieme a cartesio e ^ZaSt^.\n Data 16/04/2004</span>");
		gtk_label_set_justify (GTK_LABEL(label),GTK_JUSTIFY_CENTER);
		gtk_container_add (GTK_CONTAINER(about), label);
		gtk_widget_show_all (about);
		check = 1;
	}
	else
		 gtk_window_deiconify (GTK_WINDOW (about));
	// --- About creata
}

void destroy_about (void)
{
	gtk_widget_destroy (about);
	check = 0;
}
