#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <unistd.h>

GtkWidget *text1, *text2, *text3, *text4;
int pid;

void attiva(void);
void disattiva(void);
void chiudi(void);

int main( int   argc, char *argv[] )
{
	GtkWidget *window, *button1, *button2, *button3, *label;
	GtkWidget *hbox1, *hbox2, *hbox3, *hbox4, *hbox5, *vbox;
	
	gtk_init(&argc, &argv);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	g_signal_connect (G_OBJECT (window), "destroy",G_CALLBACK (gtk_main_quit),NULL);

	vbox = gtk_vbox_new (FALSE, 5);
	gtk_window_set_title (GTK_WINDOW (window), "OpenVPN Gui");
	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_container_set_border_width (GTK_CONTAINER (window), 5);

	hbox1 = gtk_hbox_new (FALSE, 5);
	gtk_box_pack_start (GTK_BOX (vbox), hbox1, FALSE, FALSE, 0);
	label = gtk_label_new("Host Locale Privato     ");
	gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 0);
	gtk_label_set_justify(GTK_LABEL (label) ,GTK_JUSTIFY_RIGHT);
	text1 = gtk_entry_new();
	gtk_box_pack_start (GTK_BOX (hbox1), text1, FALSE, FALSE, 0);

	hbox2 = gtk_hbox_new (FALSE, 5);
	gtk_box_pack_start (GTK_BOX (vbox), hbox2, FALSE, FALSE, 0);
	label = gtk_label_new("Host Remoto Privato   ");
	gtk_box_pack_start (GTK_BOX (hbox2), label, FALSE, FALSE, 0);
	gtk_label_set_justify(GTK_LABEL (label) ,GTK_JUSTIFY_RIGHT);
	text2 = gtk_entry_new();
	gtk_box_pack_start (GTK_BOX (hbox2), text2, FALSE, FALSE, 0);

	hbox3 = gtk_hbox_new (FALSE, 5);
	gtk_box_pack_start (GTK_BOX (vbox), hbox3, FALSE, FALSE, 0);
	label = gtk_label_new("Host Remoto Pubblico");
	gtk_box_pack_start (GTK_BOX (hbox3), label, FALSE, FALSE, 0);
	gtk_label_set_justify(GTK_LABEL (label) ,GTK_JUSTIFY_RIGHT);
	text3 = gtk_entry_new();
	gtk_box_pack_start (GTK_BOX (hbox3), text3, FALSE, FALSE, 0);

	hbox4 = gtk_hbox_new (FALSE, 5);
	gtk_box_pack_start (GTK_BOX (vbox), hbox4, FALSE, FALSE, 0);
	label = gtk_label_new("Locazione della key    ");
	gtk_box_pack_start (GTK_BOX (hbox4), label, FALSE, FALSE, 0);
	gtk_label_set_justify(GTK_LABEL (label) ,GTK_JUSTIFY_RIGHT);
	text4 = gtk_entry_new();
	gtk_box_pack_start (GTK_BOX (hbox4), text4, FALSE, FALSE, 0);

	hbox5 = gtk_hbox_new (FALSE, 5);
	gtk_box_pack_start (GTK_BOX (vbox), hbox5, FALSE, FALSE, 0);
	button1 = gtk_button_new_with_label ("Connetti");
	gtk_box_pack_start (GTK_BOX (hbox5), button1, FALSE, FALSE, 0);
	g_signal_connect (G_OBJECT (button1), "clicked", G_CALLBACK (attiva), NULL);
	button2 = gtk_button_new_with_label ("Disconnetti");
        gtk_box_pack_start (GTK_BOX (hbox5), button2, FALSE, FALSE, 0);
        g_signal_connect (G_OBJECT (button2), "clicked", G_CALLBACK (disattiva), NULL);
        button3 = gtk_button_new_with_label ("Chiudi");
        gtk_box_pack_start (GTK_BOX (hbox5), button3, FALSE, FALSE, 0);
        g_signal_connect (G_OBJECT (button3), "clicked", G_CALLBACK (chiudi), NULL);
	
	gtk_widget_show_all(window);

	gtk_main (); //attende gli eventi
	return 0;
}

void attiva(void)
{	
	FILE *oPid;
	pid = fork();	//duplica il processo corrente

	if (!pid) 
		execlp("openvpn","openvpn","--remote",gtk_entry_get_text(GTK_ENTRY(text3)),"--dev","tun1","--ifconfig",gtk_entry_get_text(GTK_ENTRY(text1)),gtk_entry_get_text(GTK_ENTRY(text2)),"--verb","5","--secret",gtk_entry_get_text(GTK_ENTRY(text4)),NULL);
		//avvia openvpn con le caratteristiche richieste
		oPid = fopen("openVPN.pid","w");
	fprintf(oPid,"%d",pid);	// salva su file il pid del processo
	fclose(oPid);
}

void disattiva(void)
{	
	if (pid != 0) {
		kill(pid,1); //termina il processo di openvpn
		waitpid(pid,NULL,0);
	} //elimina lo "zombie"
	pid = 0; //setta a 0 il pid per indicare che nssun processo  runnato
}

void chiudi(void)
{
	if (pid != 0)
		kill(pid,1); //termina il processo di openvpn se questo  runnato
	
	gtk_main_quit(); // termina la gui
}
